using bdAntifraude.db;
using bdAntifraude.dbcontext;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.EntityFrameworkCore;

namespace SwaggerAntifraude.Controllers
{
    [ApiController]
    [Route("api/[controller]")]
    public class FORMACIONController : GenericoController<FORMACION, int>
    {
        public FORMACIONController()
            : base()
        {
        }


        [Authorize(Policy = "LecturaPolicy")]
        [HttpGet("{id}")]
        public override IActionResult GetById(int id)
        {
            try
            {
                using (var context = tsGestionAntifraude.NuevoContexto(SoloLectura: true, UseLazyLoadingProxies: false))
                {
                    //var dbSet = context.Set<PUESTOS>();
                    var entity = context.FORMACION
                        .Include(x => x.IDPERSONANavigation)
                    .AsNoTracking()
                    .FirstOrDefault(v => v.IDFORMACION == id);

                    if (entity == null)
                        return NotFound();

                    return Ok(entity);
                }
            }
            catch (Exception ex)
            {
                return StatusCode(500, $"Error interno del servidor: {ex.Message}");
            }
        }
        [Authorize(Policy = "LecturaPolicy")]
        [HttpGet("formacionespersona/{idPersona}")]
        public async Task<IActionResult> FormacionPersona(int idPersona)
        {
            try
            {
                using (var context = tsGestionAntifraude.NuevoContexto(SoloLectura: true, UseLazyLoadingProxies: false))
                {
                    // Consulta con Includes necesarios
                    var entity = await context.FORMACION
                    .Include(p => p.IDPERSONANavigation)
                    .AsNoTracking()
                    .Where(p => p.IDPERSONA == idPersona).ToListAsync();

                    // Verifica si la entidad no se encontró
                    if (entity == null)
                        return NotFound($"El puesto con ID {idPersona} no fue encontrado.");

                    // Devuelve la entidad con las relaciones cargadas
                    return Ok(entity);
                }
            }
            catch (Exception ex)
            {
                return StatusCode(500, $"Error interno del servidor: {ex.Message}");
            }
        }
    }
   
}
